diff -uNrd ircd-hybrid-6.3.1.dist/src/m_error.c ircd-hybrid-6.3.1/src/m_error.c
--- ircd-hybrid-6.3.1.dist/src/m_error.c	Thu Jul 26 12:14:26 2001
+++ ircd-hybrid-6.3.1/src/m_error.c	Tue Apr 29 22:27:28 2003
@@ -29,6 +29,7 @@
 #include "numeric.h"
 #include "send.h"
 #include "s_debug.h"
+#include "s_log.h"
 
 /*
  * m_functions execute protocol messages on this server:
@@ -97,7 +98,6 @@
  */
 int m_error(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
 {
-#ifndef HIDE_ERROR_MESSAGES
   char* para;
 
   para = (parc > 1 && *parv[1] != '\0') ? parv[1] : "<>";
@@ -113,23 +113,48 @@
   if (IsPerson(cptr) || IsUnknown(cptr))
     return 0;
 
-#if (defined SERVERHIDE) || (defined HIDE_SERVERS_IPS)
+  /* this is less ugly than it was before, if you ask me.
+   * at least with this logic, everything's clustered, and
+   * there's not a crapload of code duplic.  anyways, the
+   * logic is this:
+   * if the source is the server it came from,
+   *   if HIDE_ERROR_MESSAGES is undefined,
+   *     sendto_realops(hey i got an error me love you long time)
+   *       [ and hide the remote servers ip if HIDE_SERVERS_IPS ]
+   *   always: log(blah blah blah, with the real ip)
+   * otherwise, if this was sent along from another server:
+   *   same logic as above, but messages contain "via x"
+   *
+   * booooooooing.
+   */
+
   if (cptr == sptr)
+  {
+#ifndef HIDE_ERROR_MESSAGES
     sendto_realops("ERROR :from %s -- %s",
+#if (defined SERVERHIDE) || (defined HIDE_SERVERS_IPS)
                get_client_name(cptr, MASK_IP), para);
+#else /* SERVERHIDE || HIDE_SERVERS_IPS */
+               get_client_name(cptr, FALSE), para);
+#endif /* SERVERHIDE || HIDE_SERVERS_IPS */
+#endif /* !HIDE_ERROR_MESSAGES */
+    log(L_NOTICE, "ERROR from %s -- %s",
+               get_client_name(cptr, SHOW_IP), para);
+  }
   else
+  {
+#ifndef HIDE_ERROR_MESSAGES
     sendto_realops("ERROR :from %s via %s -- %s", sptr->name,
+#if (defined SERVERHIDE) || (defined HIDE_SERVERS_IPS)
                get_client_name(cptr, MASK_IP), para);
-#else	       
-  if (cptr == sptr)
-    sendto_realops("ERROR :from %s -- %s",
+#else /* SERVERHIDE || HIDE_SERVERS_IPS */
                get_client_name(cptr, FALSE), para);
-  else
-    sendto_realops("ERROR :from %s via %s -- %s", sptr->name,
-               get_client_name(cptr,FALSE), para);
-#endif
+#endif /* SERVERHIDE || HIDE_SERVERS_IPS */
+#endif /* !HIDE_ERROR_MESSAGES */
+    log(L_NOTICE, "ERROR from %s via %s -- %s", sptr->name,
+        get_client_name(cptr, SHOW_IP), para);
+  }
 
-#endif /* HIDE_ERRORS */
   return 0;
 }
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_etrace.c ircd-hybrid-6.3.1/src/m_etrace.c
--- ircd-hybrid-6.3.1.dist/src/m_etrace.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-6.3.1/src/m_etrace.c	Mon Apr 21 20:53:56 2003
@@ -0,0 +1,165 @@
+/*
+ *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_etrace.c: Gives local opers a trace output with added info.
+ *
+ *  Copyright (C) 2002 ircd-ratbox development team
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id: m_etrace.c,v 1.4 2003/03/05 14:20:16 leeh Exp $
+ */
+
+#include "m_commands.h"
+#include "class.h"
+#include "client.h"
+#include "common.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_bsd.h"
+#include "s_serv.h"
+#include "send.h"
+
+#include <string.h>
+#include <time.h>
+
+/*
+ * m_functions execute protocol messages on this server:
+ *
+ *      cptr    is always NON-NULL, pointing to a *LOCAL* client
+ *              structure (with an open socket connected!). This
+ *              identifies the physical socket where the message
+ *              originated (or which caused the m_function to be
+ *              executed--some m_functions may call others...).
+ *
+ *      sptr    is the source of the message, defined by the
+ *              prefix part of the message if present. If not
+ *              or prefix not found, then sptr==cptr.
+ *
+ *              (!IsServer(cptr)) => (cptr == sptr), because
+ *              prefixes are taken *only* from servers...
+ *
+ *              (IsServer(cptr))
+ *                      (sptr == cptr) => the message didn't
+ *                      have the prefix.
+ *
+ *                      (sptr != cptr && IsServer(sptr) means
+ *                      the prefix specified servername. (?)
+ *
+ *                      (sptr != cptr && !IsServer(sptr) means
+ *                      that message originated from a remote
+ *                      user (not local).
+ *
+ *              combining
+ *
+ *              (!IsServer(sptr)) means that, sptr can safely
+ *              taken as defining the target structure of the
+ *              message in this server.
+ *
+ *      *Always* true (if 'parse' and others are working correct):
+ *
+ *      1)      sptr->from == cptr  (note: cptr->from == cptr)
+ *
+ *      2)      MyConnect(sptr) <=> sptr == cptr (e.g. sptr
+ *              *cannot* be a local connection, unless it's
+ *              actually cptr!). [MyConnect(x) should probably
+ *              be defined as (x == x->from) --msa ]
+ *
+ *      parc    number of variable parameter strings (if zero,
+ *              parv is allowed to be NULL)
+ *
+ *      parv    a NULL terminated list of parameter pointers,
+ *
+ *                      parv[0], sender (prefix string), if not present
+ *                              this points to an empty string.
+ *                      parv[1]...parv[parc-1]
+ *                              pointers to additional parameters
+ *                      parv[parc] == NULL, *always*
+ *
+ *              note:   it is guaranteed that parv[0]..parv[parc-1] are all
+ *                      non-NULL pointers.
+ */
+
+/*
+** m_etrace - Extended TRACE - See doc/ETRACE.txt
+**      parv[0] = sender prefix
+**      parv[1] = servername
+*/
+int     m_etrace(struct Client *cptr,
+                struct Client *sptr,
+                int parc,
+                char *parv[])
+{
+  int   i;
+  struct Client       *acptr = NULL;
+  
+  if (check_registered(sptr))
+    return 0;
+
+  if (!IsClient(sptr))
+    return 0;
+
+  if (!MyConnect(sptr))
+    return 0;
+
+  if (!IsAnOper(sptr))
+  {
+    sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+    return 0;
+  }
+
+  sendto_realops_flags(FLAGS_SPY, "ETRACE requested by %s (%s@%s)",
+                       sptr->name, sptr->username, sptr->host);
+
+  for (i = 0; i <= highest_fd; i++)
+    {
+      const char* ip;
+      
+      if (!(acptr = local[i])) /* Local Connection? */
+        continue;
+#ifdef HIDE_SPOOF_IPS
+      if (IsIPSpoof(acptr))
+        ip = "255.255.255.255";
+      else
+#endif
+        ip = inetntoa((char*) &acptr->ip);
+
+      switch(acptr->status)
+        {
+        case STAT_CLIENT:
+              sendto_one(sptr, form_str(RPL_ETRACE), me.name, parv[0],
+                         IsAnOper(acptr) ? "Oper" : "User",
+                         get_client_class(acptr), acptr->name,
+                         acptr->username, acptr->host, ip, acptr->info);
+              break;
+        default: /* Items ETRACE doesn't care about -Hwy */
+              break;
+        }
+    }
+  sendto_one(sptr, form_str(RPL_ENDOFTRACE),me.name,parv[0],me.name);
+  return 0;
+}
+
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_flags.c ircd-hybrid-6.3.1/src/m_flags.c
--- ircd-hybrid-6.3.1.dist/src/m_flags.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-6.3.1/src/m_flags.c	Sat May  3 10:18:53 2003
@@ -0,0 +1,344 @@
+/*
+ *  m_flags.c: Implements comstud-style mode flags.
+ *
+ *  Copyright 2002 by W. Campbell and the ircd-hybrid development team
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id: m_flags.c,v 1.12 2002/11/21 20:16:30 leeh Exp $
+ */
+
+#include "m_commands.h"
+#include "s_user.h"
+#include "client.h"
+#include "common.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_serv.h"
+#include "send.h"
+#include "struct.h"
+#include "m_flags.h"
+#include <ctype.h>
+
+#ifdef FLAGS_COMMAND
+
+/* Backported from my m_flags.c module in Hybrid 7's contrib/ -Hwy */
+
+/* FLAGS requires it's own mini parser, since the last parameter in it can
+** contain a number of FLAGS.  CS handles FLAGS mode1 mode2 OR
+** FLAGS :mode1 mode2, but not both mixed.
+**
+** The best way to match a flag to a mode is with a simple table
+*/
+
+struct FlagTable
+{
+  char *name;
+  int mode;
+  int oper;
+};
+
+static struct FlagTable flag_table[] =
+{
+  /* name               mode it represents      oper only? */
+  { "OWALLOPS",         FLAGS_OPERWALL,         1 },
+  { "SWALLOPS",         FLAGS_WALLOP,           0 },
+  { "STATSNOTICES",     FLAGS_SPY,              1 },
+    /* We don't have a separate OKILL and SKILL modes */
+  { "OKILLS",           FLAGS_SKILL,            0 },
+  { "SKILLS",           FLAGS_SKILL,            0 },
+  { "SNOTICES",         FLAGS_SERVNOTICE,       0 },
+    /* We don't have separate client connect and disconnect modes */
+  { "CLICONNECTS",      FLAGS_CCONN,            1 },
+  { "CLIDISCONNECTS",   FLAGS_CCONN,            1 },
+    /* I'm taking a wild guess here... */
+  { "THROTTLES",        FLAGS_REJ,              1 },
+    /* NICKCHANGES must be checked for separately */
+  { "IPMISMATCHES",     FLAGS_UNAUTH,           1 },
+  { "LWALLOPS",         FLAGS_LOCOPS,           1 },
+    /* These aren't separate on Hybrid */
+  { "CONNECTS",         FLAGS_EXTERNAL,         1 },
+  { "SQUITS",           FLAGS_EXTERNAL,         1 },
+    /* Now we have our Hybrid specific flags */
+  { "FULL",             FLAGS_FULL,             1 },
+    /* Not in CS, but we might as well put it here */
+  { "INVISIBLE",        FLAGS_INVISIBLE,        0 },
+  { "BOTS",             FLAGS_BOTS,             1 },
+  { "UNAUTH",           FLAGS_UNAUTH,           1 },
+  { "JUPE",             FLAGS_JUPE,             1 },
+  { "DEBUG",            FLAGS_DEBUG,            1 },
+  { NULL,               0,                      0 }
+};
+
+/* We won't control INVISIBLE in here */
+
+#define FL_ALL_USER_FLAGS (FLAGS_WALLOP | FLAGS_SKILL | FLAGS_SERVNOTICE )
+
+/* and we don't control NCHANGES here either */
+
+#define FL_ALL_OPER_FLAGS (FL_ALL_USER_FLAGS | FLAGS_CCONN | FLAGS_REJ |\
+                           FLAGS_FULL | FLAGS_SPY | FLAGS_DEBUG |\
+                           FLAGS_OPERWALL | FLAGS_BOTS | FLAGS_EXTERNAL |\
+                           FLAGS_UNAUTH | FLAGS_LOCOPS | FLAGS_JUPE )
+
+char *set_flags_to_string(struct Client *client_p)
+{
+  /* XXX - list all flags that we have set on the client */
+  static char setflags[BUFSIZE + 1];
+  int i;
+
+  /* Clear it to begin with, we'll be doing a lot of ircsprintf's */
+  setflags[0] = '\0';
+
+  /* Unlike unset_flags_to_string(), we don't have to care about oper
+  ** flags and not showing them
+  */
+
+  for (i = 0; flag_table[i].name; i++)
+  {
+    if (client_p->umodes & flag_table[i].mode)
+    {
+      ircsprintf(setflags, "%s %s", setflags, flag_table[i].name);
+    }
+  }
+
+    /* You can only be set +NICKCHANGES if you are an oper and
+    ** IsOperN(client_p) is true
+    */
+    if (client_p->umodes & FLAGS_NCHANGE)
+    {
+      ircsprintf(setflags, "%s %s", setflags, "NICKCHANGES");
+    }
+
+  return setflags;
+}
+
+char *unset_flags_to_string(struct Client *client_p)
+{
+  /* Inverse of above */
+  /* XXX - list all flags that we do NOT have set on the client */
+  static char setflags[BUFSIZE + 1];
+  int i,isoper;
+
+  /* Clear it to begin with, we'll be doing a lot of ircsprintf's */
+  setflags[0] = '\0';
+
+  if (IsOper(client_p))
+    isoper = 1;
+  else
+    isoper = 0;
+
+  for (i = 0; flag_table[i].name; i++)
+  {
+    if ( !(client_p->umodes & flag_table[i].mode))
+    {
+      if (!isoper && flag_table[i].oper)
+        continue;
+      ircsprintf(setflags, "%s %s", setflags, flag_table[i].name);
+    }
+  }
+
+  if (IsOper(client_p) && IsSetOperN(client_p))
+  {
+    if ( !(client_p->umodes & FLAGS_NCHANGE))
+    {
+      ircsprintf(setflags, "%s %s", setflags, "NICKCHANGES");
+    }
+  }
+
+  return setflags;
+}
+
+/*
+** m_flags
+**      parv[0] = sender prefix
+**      parv[1] = parameter
+*/
+int m_flags(struct Client *client_p, struct Client *source_p,
+            int parc, char *parv[])
+{
+  int i,j;
+  int isadd;
+  int setflags;
+  int isgood;
+  char *p;
+  char *flag;
+
+  if (!MyClient(source_p))
+    return 0;
+
+  if (parc < 2)
+  {
+    /* Generate a list of what flags you have and what you are missing,
+    ** and send it to the user
+    */
+    sendto_one(source_p, ":%s NOTICE %s :Current flags:%s",
+               me.name, parv[0], set_flags_to_string(source_p));
+    sendto_one(source_p, ":%s NOTICE %s :Current missing flags:%s",
+               me.name, parv[0], unset_flags_to_string(source_p));
+    return 0;
+  }
+
+  /* Preserve the current flags */
+  setflags = source_p->umodes;
+
+  for (i = 1; i < parc; i++)
+  {
+    for (flag = strtoken(&p, parv[i], " "); flag;
+         flag = strtoken(&p, NULL, " "))
+    {
+      /* We default to being in ADD mode */
+      isadd = 1;
+
+      /* We default to being in BAD mode */
+      isgood = 0;
+
+      if (!isalpha(flag[0]))
+      {
+        if (flag[0] == '-')
+          isadd = 0;
+        else if (flag[0] == '+')
+          isadd = 1;
+        flag++;
+      }
+
+      if (IsAnOper(source_p))
+      {
+        /* support ALL here */
+        if (!irccmp(flag, "ALL"))
+        {
+          if (isadd)
+            source_p->umodes |= FL_ALL_OPER_FLAGS;
+          else
+            source_p->umodes &= ~FL_ALL_OPER_FLAGS;
+#ifndef FLAGS_ANNOUNCE
+          sendto_one(source_p, ":%s NOTICE %s :Current flags:%s",
+                     me.name, parv[0], set_flags_to_string(source_p));
+          sendto_one(source_p, ":%s NOTICE %s :Current missing flags:%s",
+                     me.name, parv[0], unset_flags_to_string(source_p));
+#endif
+          send_umode_out(client_p, source_p, setflags);
+          return 0;
+        }
+
+        if (!irccmp(flag, "NICKCHANGES"))
+        {
+          if (!IsSetOperN(source_p))
+          {
+            sendto_one(source_p,
+                       ":%s NOTICE %s :*** You need oper and N flag for +n",
+                       me.name,parv[0]);
+            continue;
+          }
+          if (isadd)
+            source_p->umodes |= FLAGS_NCHANGE;
+          else
+            source_p->umodes &= ~FLAGS_NCHANGE;
+          isgood = 1;
+          continue;
+        }
+
+        for (j = 0; flag_table[j].name; j++)
+        {
+          if (!irccmp(flag, flag_table[j].name))
+          {
+            if (isadd)
+              source_p->umodes |= flag_table[j].mode;
+            else
+              source_p->umodes &= ~ (flag_table[j].mode);
+            isgood = 1;
+            continue;
+          }
+        }
+        /* This for ended without matching a valid FLAG, here is where
+        ** I want to operate differently than ircd-comstud, and just ignore
+        ** the invalid flag, send a warning and go on.
+        */
+        if (!isgood)
+          sendto_one(source_p, ":%s NOTICE %s :Invalid FLAGS: %s (IGNORING)",
+                     me.name, parv[0], flag);
+      }
+      else
+      {
+        /* support ALL here */
+        if (!irccmp(flag, "ALL"))
+        {
+          if (isadd)
+            source_p->umodes |= FL_ALL_USER_FLAGS;
+          else
+            source_p->umodes &= ~FL_ALL_USER_FLAGS;
+#ifndef FLAGS_ANNOUNCE
+          sendto_one(source_p, ":%s NOTICE %s :Current flags:%s",
+                     me.name, parv[0], set_flags_to_string(source_p));
+          sendto_one(source_p, ":%s NOTICE %s :Current missing flags:%s",
+                     me.name, parv[0], unset_flags_to_string(source_p));
+#endif
+          send_umode_out(client_p, source_p, setflags);
+          return 0;
+        }
+
+        for (j = 0; flag_table[j].name; j++)
+        {
+          if (!flag_table[j].oper && !irccmp(flag, flag_table[j].name))
+          {
+            if (isadd)
+              source_p->umodes |= flag_table[j].mode;
+            else
+              source_p->umodes &= ~ (flag_table[j].mode);
+            isgood = 1;
+            continue;
+          }
+        }
+        /* This for ended without matching a valid FLAG, here is where
+        ** I want to operate differently than ircd-comstud, and just ignore
+        ** the invalid flag, send a warning and go on.
+        */
+        if (!isgood)
+          sendto_one(source_p, ":%s NOTICE %s :Invalid FLAGS: %s (IGNORING)",
+                     me.name, parv[0], flag);
+      }
+    }
+  }
+
+  /* All done setting the flags, print the notices out to the user
+  ** telling what flags they have and what flags they are missing
+  */
+#ifndef FLAGS_ANNOUNCE
+  /* We only want to send it here when FLAGS_ANNOUNCE is not in use,
+  ** since send_umode_out() will send this same message to the user.
+  ** Without this ifndef, the user will receive the current set
+  ** and missing flags NOTICE's twice
+  */
+  sendto_one(source_p, ":%s NOTICE %s :Current flags:%s",
+             me.name, parv[0], set_flags_to_string(source_p));
+  sendto_one(source_p, ":%s NOTICE %s :Current missing flags:%s",
+             me.name, parv[0], unset_flags_to_string(source_p));
+
+#endif
+  send_umode_out(client_p, source_p, setflags);
+  return 0;
+}
+#endif /* FLAGS_COMMAND */
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_gline.c ircd-hybrid-6.3.1/src/m_gline.c
--- ircd-hybrid-6.3.1.dist/src/m_gline.c	Sat Dec 15 11:24:09 2001
+++ ircd-hybrid-6.3.1/src/m_gline.c	Sat Apr 19 21:06:45 2003
@@ -403,7 +403,7 @@
   }
   
   /* dont allow glines with : in, theyll break the conf */
-  if(strchr(luser, ':') || strchr(lhost, ':') || strchr(lreason, ':'))
+  if(strchr(luser, ':') || strchr(lreason, ':'))
   {
     if(local_client)
       sendto_one(sptr, ":%s NOTICE %s :Invalid character ':' in gline",
@@ -533,7 +533,10 @@
   if (safe_write(sptr,filenamebuf,out,buffer))
     return;
 
-  ircsprintf(buffer, "K:%s:%s:%s\n", host,user,reason);
+  if (strchr(host, ':'))
+    ircsprintf(buffer, "# IPv6 Host, invalid (%s@%s) [%s]", user,host,reason);
+  else
+    ircsprintf(buffer, "K:%s:%s:%s\n", host,user,reason);
   if (safe_write(sptr,filenamebuf,out,buffer))
     return;
 
@@ -852,6 +855,20 @@
           MyFree(tmp_pending_ptr->reason2);
           MyFree(tmp_pending_ptr);
         }
+      else if( find_is_glined(gline_pending_ptr->host, gline_pending_ptr->user))
+        {
+          /* Expire any pending GLINE's if they were triggered and set. */
+          if(last_gline_pending_ptr)
+            last_gline_pending_ptr->next = gline_pending_ptr->next;
+          else
+            pending_glines = gline_pending_ptr->next;
+
+          tmp_pending_ptr = gline_pending_ptr;
+          gline_pending_ptr = gline_pending_ptr->next;
+          MyFree(tmp_pending_ptr->reason1);
+          MyFree(tmp_pending_ptr->reason2);
+          MyFree(tmp_pending_ptr);
+        }
       else
         {
           last_gline_pending_ptr = gline_pending_ptr;
@@ -944,7 +961,8 @@
               (irccmp(gline_pending_ptr->oper_server1,oper_server) == 0) )
             {
               /* This oper or server has already "voted" */
-              sendto_realops("oper or server has already voted");
+              sendto_realops("oper or server has already voted: [%s!%s@%s] on %s",
+                             oper_nick, oper_user, oper_host, oper_server);
               return NO;
             }
 
@@ -957,7 +975,8 @@
                   (irccmp(gline_pending_ptr->oper_server2,oper_server)==0))
                 {
                   /* This oper or server has already "voted" */
-                  sendto_realops("oper or server has already voted");
+                  sendto_realops("oper or server has already voted: [%s!%s@%s] on %s",
+                                 oper_nick, oper_user, oper_host, oper_server);
                   return NO;
                 }
 
